Index: /branches/ODCCP/modules/vci_mem_cache/caba/source/src/vci_mem_cache.cpp
===================================================================
--- /branches/ODCCP/modules/vci_mem_cache/caba/source/src/vci_mem_cache.cpp	(revision 543)
+++ /branches/ODCCP/modules/vci_mem_cache/caba/source/src/vci_mem_cache.cpp	(revision 544)
@@ -1239,14 +1301,7 @@
                         error            = 0;
                         r_config_lock    = true;
-                        if ( rdata == 0 )
-                        {
-                            r_tgt_cmd_srcid = p_vci_tgt.srcid.read();
-                            r_tgt_cmd_trdid = p_vci_tgt.trdid.read();
-                            r_tgt_cmd_pktid = p_vci_tgt.pktid.read();
-                        }
-                    }
+                        }
                     else if ( (p_vci_tgt.cmd.read() == vci_param_int::CMD_WRITE)  // release lock
-                            and (cell == MEMC_LOCK)
-                            and (p_vci_tgt.srcid.read() == r_tgt_cmd_srcid.read()) )
+                            and (cell == MEMC_LOCK) )
                     {
                         need_rsp         = true;
@@ -1255,6 +1310,5 @@
                     }
                     else if ( (p_vci_tgt.cmd.read() == vci_param_int::CMD_WRITE)   // set addr_lo
-                            and (cell == MEMC_ADDR_LO)
-                            and (p_vci_tgt.srcid.read() == r_tgt_cmd_srcid.read()) )
+                            and (cell == MEMC_ADDR_LO) )
                     {
                         assert( ((wdata % (m_words*vci_param_int::B)) == 0) and
@@ -1264,9 +1318,8 @@
                         error            = 0;
                         r_config_address = (r_config_address.read() & 0xFFFFFFFF00000000LL) |
-                            (addr_t)p_vci_tgt.wdata.read();
+                            ((addr_t)wdata);
                     }
                     else if ( (p_vci_tgt.cmd.read() == vci_param_int::CMD_WRITE)   // set addr_hi
-                            and (cell == MEMC_ADDR_HI)
-                            and (p_vci_tgt.srcid.read() == r_tgt_cmd_srcid.read()) )
+                            and (cell == MEMC_ADDR_HI) )
 
                     {
@@ -1274,24 +1327,22 @@
                         error            = 0;
                         r_config_address = (r_config_address.read() & 0x00000000FFFFFFFFLL) |
-                            ((addr_t)p_vci_tgt.wdata.read())<<32;
+                            (((addr_t) wdata) << 32);
                     }
                     else if ( (p_vci_tgt.cmd.read() == vci_param_int::CMD_WRITE)   // set buf_lines
-                            and (cell == MEMC_BUF_LENGTH)
-                            and (p_vci_tgt.srcid.read() == r_tgt_cmd_srcid.read()) )
+                            and (cell == MEMC_BUF_LENGTH) )
                     {
                         need_rsp         = true;
                         error            = 0;
-                        size_t lines = (size_t)(p_vci_tgt.wdata.read()/(m_words<<2));
-                        if ( r_config_address.read()%(m_words*4) ) lines++;
+                        size_t lines = wdata/(m_words<<2);
+                        if ( wdata%(m_words<<2) ) lines++;
                         r_config_cmd_lines  = lines;
                         r_config_rsp_lines  = lines;
                     }
                     else if ( (p_vci_tgt.cmd.read() == vci_param_int::CMD_WRITE)   // set cmd type
-                            and (cell == MEMC_CMD_TYPE)
-                            and (p_vci_tgt.srcid.read() == r_tgt_cmd_srcid.read()) )
+                            and (cell == MEMC_CMD_TYPE) )
                     {
                         need_rsp         = false;
                         error            = 0;
-                        r_config_cmd     = p_vci_tgt.wdata.read();
+                        r_config_cmd     = wdata;
 
                         // prepare delayed response from CONFIG FSM
@@ -1311,4 +1362,7 @@
                         if ( r_tgt_cmd_to_tgt_rsp_req.read() ) break;
 
+                        r_tgt_cmd_to_tgt_rsp_srcid = p_vci_tgt.srcid.read();
+                        r_tgt_cmd_to_tgt_rsp_trdid = p_vci_tgt.trdid.read();
+                        r_tgt_cmd_to_tgt_rsp_pktid = p_vci_tgt.pktid.read();
                         r_tgt_cmd_to_tgt_rsp_req   = true;
                         r_tgt_cmd_to_tgt_rsp_error = error;
@@ -1371,6 +1425,16 @@
 #endif
                     cmd_read_fifo_put = true;
-                    if(p_vci_tgt.cmd.read() == vci_param_int::CMD_LOCKED_READ) m_cpt_ll++;
-                    else                                                       m_cpt_read++;
+                    // <Activity counters>
+                    if (p_vci_tgt.cmd.read() == vci_param_int::CMD_LOCKED_READ) {
+                        if (is_local_req(p_vci_tgt.srcid.read())) m_cpt_ll_local++;
+                        else                                      m_cpt_ll_remote++;
+                        m_cpt_ll_cost += req_distance(p_vci_tgt.srcid.read()); // LL on a single word
+                    }
+                    else {
+                        if (is_local_req(p_vci_tgt.srcid.read())) m_cpt_read_local++;
+                        else                                      m_cpt_read_remote++;
+                        m_cpt_read_cost += m_words * req_distance(p_vci_tgt.srcid.read());
+                    }
+                    // </Activity counters>
                     r_tgt_cmd_fsm = TGT_CMD_IDLE;
                 }
@@ -1394,5 +1458,29 @@
 #endif
                     cmd_write_fifo_put = true;
-                    if(p_vci_tgt.eop)  r_tgt_cmd_fsm = TGT_CMD_IDLE;
+                    // <Activity counters>
+                    if (p_vci_tgt.cmd.read() == vci_param_int::CMD_NOP) {
+                        m_cpt_sc_cost += req_distance(p_vci_tgt.srcid.read());
+                }
+                    else {
+                        if (is_local_req(p_vci_tgt.srcid.read())) m_cpt_write_flits_local++;
+                        else                                      m_cpt_write_flits_remote++;
+                        m_cpt_write_cost += req_distance(p_vci_tgt.srcid.read());
+                    }
+                    // </Activity counters>
+
+                    if (p_vci_tgt.eop) {
+                        // <Activity counters>
+                        if (p_vci_tgt.cmd.read() == vci_param_int::CMD_NOP) {
+                            if (is_local_req(p_vci_tgt.srcid.read())) m_cpt_sc_local++;
+                            else                                      m_cpt_sc_remote++;
+
+                        }
+                        else {
+                            if (is_local_req(p_vci_tgt.srcid.read())) m_cpt_write_local++;
+                            else                                      m_cpt_write_remote++;
+                        }
+                        // </Activity counters>
+                        r_tgt_cmd_fsm = TGT_CMD_IDLE;
+                    }
                 }
                 break;
@@ -1422,5 +1510,12 @@
 #endif
                     cmd_cas_fifo_put = true;
-                    if(p_vci_tgt.eop) r_tgt_cmd_fsm = TGT_CMD_IDLE;
+                    if (p_vci_tgt.eop) {
+                        // <Activity counters>
+                        if (is_local_req(p_vci_tgt.srcid.read())) m_cpt_cas_local++;
+                        else                                      m_cpt_cas_remote++;
+                        m_cpt_cas_cost += req_distance(p_vci_tgt.srcid.read());
+                        // </Activity counters>
+                        r_tgt_cmd_fsm = TGT_CMD_IDLE;
+                }
                 }
                 break;
@@ -1751,15 +1846,15 @@
                     DirectoryEntry entry = m_cache_directory.read(r_config_address.read(), way);
 
-                    if ( entry.valid and                            // hit & inval command
-                            (r_config_cmd.read() == MEMC_CMD_INVAL) ) 
-                    {
-                        r_config_dir_way        = way;
-                        r_config_dir_copy_inst  = entry.owner.inst;
-                        r_config_dir_copy_srcid = entry.owner.srcid;
-                        r_config_dir_is_cnt     = entry.is_cnt;
-                        r_config_dir_lock       = entry.lock;
-                        r_config_dir_count      = entry.count;
-                        r_config_dir_ptr        = entry.ptr;
-
+                    r_config_dir_way        = way;
+                    r_config_dir_copy_inst  = entry.owner.inst;
+                    r_config_dir_copy_srcid = entry.owner.srcid;
+                    r_config_dir_is_cnt     = entry.is_cnt;
+                    r_config_dir_lock       = entry.lock;
+                    r_config_dir_count      = entry.count;
+                    r_config_dir_ptr        = entry.ptr;
+
+                    if (entry.valid and                            // hit & inval command
+                            (r_config_cmd.read() == MEMC_CMD_INVAL)) 
+                    {
                         r_config_fsm    = CONFIG_IVT_LOCK;
                     }
@@ -1774,5 +1869,4 @@
                         r_config_cmd_lines = r_config_cmd_lines.read() - 1;
                         r_config_rsp_lines = r_config_rsp_lines.read() - 1;
-                        r_config_cmd_lines = r_config_cmd_lines.read() - 1;
                         r_config_address   = r_config_address.read() + (m_words<<2);
                         r_config_fsm       = CONFIG_LOOP;
@@ -1826,7 +1920,5 @@
                             entry.owner.inst  = r_config_dir_copy_inst.read();
                             entry.owner.srcid = r_config_dir_copy_srcid.read();
-                            m_cache_directory.write( set, 
-                                    way, 
-                                    entry );
+                            m_cache_directory.write( set, way, entry );
 
                             r_config_trt_index = index;
@@ -1856,17 +1948,16 @@
                     size_t          way = r_config_dir_way.read();
                     size_t          set = m_y[r_config_address.read()];
-
-                    sc_signal<data_t> config_data[16];
-                    m_cache_data.read_line( way, 
-                            set, 
-                            config_data );
-
-                    // post a PUT request in TRT
                     std::vector<data_t> data_vector;
                     data_vector.clear();
-                    for(size_t i=0; i<m_words; i++) data_vector.push_back(config_data[i].read());
+                    for(size_t word=0; word<m_words; word++) 
+                    {
+                        uint32_t data = m_cache_data.read( way, set, word );
+                        data_vector.push_back( data );
+                    }
+
+                    // post the PUT request in TRT
                     m_trt.set( r_config_trt_index.read(),
-                            false,                               // PUT
-                            m_nline[r_config_address.read()],    // nline
+                            false,                               // PUT transaction
+                            m_nline[r_config_address.read()],    // line index
                             0,                                   // srcid:       unused
                             0,                                   // trdid:       unused
@@ -1875,6 +1966,9 @@
                             0,                                   // read_length: unused
                             0,                                   // word_index:  unused
-                            std::vector<be_t>(m_words,0xF),                         
-                            data_vector);
+                            std::vector<be_t>(m_words,0xF),      // byte-enable:     unused 
+                            data_vector,                         // data to be written
+                            0,                                   // ll_key:          unused
+                            true );                              // requested by config FSM
+                    r_config_fsm = CONFIG_PUT_REQ;
 
 #if DEBUG_MEMC_CONFIG
@@ -1887,5 +1981,5 @@
                 }
                 ////////////////////
-            case CONFIG_PUT_REQ:       // PUT request to IXR_CMD_FSM
+            case CONFIG_PUT_REQ:       // post PUT request to IXR_CMD_FSM
                 {
                     if ( not r_config_to_ixr_cmd_req.read() )
@@ -1901,5 +1995,5 @@
 #if DEBUG_MEMC_CONFIG
                         if(m_debug)
-                            std::cout << "  <MEMC " << name() << " CONFIG_PUT_REQ> PUT request to IXR_CMD_FSM"
+                            std::cout << "  <MEMC " << name() << " CONFIG_PUT_REQ> post PUT request to IXR_CMD_FSM"
                                 << " / address = " << std::hex << r_config_address.read() << std::endl; 
 #endif
@@ -2706,15 +2800,5 @@
             case WRITE_IDLE:  // copy first word of a write burst in local buffer
                 {
-                    if(m_cmd_write_addr_fifo.rok())
-                    {
-                        if((m_cmd_write_pktid_fifo.read() & 0x7) == TYPE_SC)
-                        {
-                            m_cpt_sc++;
-                        }
-                        else
-                        { 
-                            m_cpt_write++;
-                            m_cpt_write_cells++;
-                        }
+                    if (not m_cmd_write_addr_fifo.rok()) break;
 
                         // consume a word in the FIFO & write it in the local buffer
@@ -2724,10 +2808,19 @@
                         r_write_address     = (addr_t)(m_cmd_write_addr_fifo.read());
                         r_write_word_index  = index;
-                        r_write_word_count  = 1;
+                    r_write_word_count  = 0;
                         r_write_data[index] = m_cmd_write_data_fifo.read();
                         r_write_srcid       = m_cmd_write_srcid_fifo.read();
                         r_write_trdid       = m_cmd_write_trdid_fifo.read();
                         r_write_pktid       = m_cmd_write_pktid_fifo.read();
-                        r_write_pending_sc  = false;
+
+                    // if SC command, get the SC key
+                    if ((m_cmd_write_pktid_fifo.read() & 0x7) == TYPE_SC)
+                    {
+                        assert( not m_cmd_write_eop_fifo.read() &&
+                                "MEMC ERROR in WRITE_IDLE state: "
+                                "invalid packet format for SC command");
+
+                        r_write_sc_key = m_cmd_write_data_fifo.read();
+                    }
 
                         // initialize the be field for all words
@@ -2738,5 +2831,5 @@
                         }
 
-                        if (m_cmd_write_eop_fifo.read() or ((m_cmd_write_pktid_fifo.read() & 0x7) == TYPE_SC))
+                    if (m_cmd_write_eop_fifo.read())
                         {
                             r_write_fsm = WRITE_DIR_REQ;
@@ -2754,5 +2847,4 @@
                                 << " / data = " << m_cmd_write_data_fifo.read() << std::endl;
 #endif
-                    }
                     break;
                 }
@@ -2760,30 +2852,45 @@
             case WRITE_NEXT:  // copy next word of a write burst in local buffer
                 {
-                    if(m_cmd_write_addr_fifo.rok())
-                    {
-
-#if DEBUG_MEMC_WRITE
-                        if(m_debug)
-                            std::cout << "  <MEMC " << name()
-                                << " WRITE_NEXT> Write another word in local buffer"
-                                << std::endl;
-#endif
-                        m_cpt_write_cells++;
+                    if (not m_cmd_write_addr_fifo.rok()) break;
 
                         // check that the next word is in the same cache line
                         assert( (m_nline[(addr_t)(r_write_address.read())] == 
-                                    m_nline[(addr_t)(m_cmd_write_addr_fifo.read())]) and
+                            m_nline[(addr_t)(m_cmd_write_addr_fifo.read())]) &&
                                 "MEMC ERROR in WRITE_NEXT state: Illegal write burst");
+
+                    size_t index = m_x[(addr_t)(m_cmd_write_addr_fifo.read())];
+                    bool   is_sc = ((m_cmd_write_pktid_fifo.read() & 0x7) == TYPE_SC);
+
+                    // check that SC command has constant address
+                    assert((not is_sc or (index == r_write_word_index)) &&
+                            "MEMC ERROR in WRITE_NEXT state: "
+                            "the address must be constant on a SC command");
+
+                    // check that SC command has two flits
+                    assert((not is_sc or m_cmd_write_eop_fifo.read()) &&
+                            "MEMC ERROR in WRITE_NEXT state: "
+                            "invalid packet format for SC command");
 
                         // consume a word in the FIFO & write it in the local buffer
                         cmd_write_fifo_get  = true;
-                        size_t index        = r_write_word_index.read() + r_write_word_count.read();
 
                         r_write_be[index]   = m_cmd_write_be_fifo.read();
                         r_write_data[index] = m_cmd_write_data_fifo.read();
+
+                    // the first flit of a SC command is the reservation key and
+                    // therefore it must not be counted as a data to write
+                    if (not is_sc)
+                    {
                         r_write_word_count  = r_write_word_count.read() + 1;
+                    }
 
                         if(m_cmd_write_eop_fifo.read()) r_write_fsm = WRITE_DIR_REQ;
-                    }
+
+#if DEBUG_MEMC_WRITE
+                    if (m_debug)
+                        std::cout << "  <MEMC " << name()
+                            << " WRITE_NEXT> Write another word in local buffer"
+                            << std::endl;
+#endif
                     break;
                 }
@@ -2792,43 +2899,31 @@
                 // and access the llsc_global_table
                 {
-                    if( r_alloc_dir_fsm.read() == ALLOC_DIR_WRITE )
-                    {
-                        if(((r_write_pktid.read() & 0x7) == TYPE_SC) and not r_write_pending_sc.read())
-                        {
-                            // We enter here if it is a new SC command
-                            // If r_write_pending_sc is set the SC is not new and has already been tested
-
-                            if(not m_cmd_write_addr_fifo.rok()) break;
-
-                            assert( m_cmd_write_eop_fifo.read() and
-                                    "MEMC ERROR in WRITE_DIR_REQ state: invalid packet format for SC command");
-
-                            size_t index    = r_write_word_index.read();
-                            bool sc_success = m_llsc_table.sc(r_write_address.read()    ,
-                                    r_write_data[index].read());
-
-                            // consume a word in the FIFO & write it in the local buffer
-                            cmd_write_fifo_get  = true;
-                            r_write_data[index] = m_cmd_write_data_fifo.read();
-                            r_write_sc_fail     = not sc_success;
-                            r_write_pending_sc  = true;
-
-                            if(not sc_success) r_write_fsm = WRITE_RSP;
-                            else               r_write_fsm = WRITE_DIR_LOCK;
-                        }
-                        else
-                        {
-                            // We enter here if it is a SW command or an already tested SC command 
-
+                    if (r_alloc_dir_fsm.read() != ALLOC_DIR_WRITE ) break;
+
+                    if ((r_write_pktid.read() & 0x7) == TYPE_SC)
+                    {
+                        // test address and key match of the SC command on the
+                        // LL/SC table without removing reservation. The reservation
+                        // will be erased after in this FSM. 
+                        bool sc_success = m_llsc_table.check(r_write_address.read(),
+                                r_write_sc_key.read());
+
+                        r_write_sc_fail     = not sc_success;
+
+                        if(not sc_success) r_write_fsm = WRITE_RSP;
+                        else               r_write_fsm = WRITE_DIR_LOCK;
+                    }
+                    else
+                    {
+                        // write burst 
 #define L2 soclib::common::uint32_log2
-                            addr_t min = r_write_address.read();
-                            addr_t max = r_write_address.read() +
-                                ((r_write_word_count.read()-1) << L2(vci_param_int::B));
+                        addr_t min = r_write_address.read();
+                        addr_t max = r_write_address.read() +
+                            (r_write_word_count.read() << L2(vci_param_int::B));
 #undef L2
 
-                            m_llsc_table.sw(min, max);
-
-                            r_write_fsm = WRITE_DIR_LOCK;
-                        }
+                        m_llsc_table.sw(min, max);
+
+                        r_write_fsm = WRITE_DIR_LOCK;
                     }
 
@@ -2916,9 +3011,16 @@
                     bool no_update = ( (r_write_count.read() == 0) or
                             (owner and (r_write_count.read() ==1) and 
-                             (r_write_pktid.read() != TYPE_SC)));
+                             ((r_write_pktid.read() & 0x7) != TYPE_SC)));
 
                     // write data in the cache if no coherence transaction
                     if(no_update)
                     {
+                        // SC command but zero copies 
+                        if ((r_write_pktid.read() & 0x7) == TYPE_SC)
+                        {
+                            m_llsc_table.sc(r_write_address.read(),
+                                            r_write_sc_key.read());
+                        }
+
                         for(size_t word=0 ; word<m_words ; word++)
                         {
@@ -2931,5 +3033,5 @@
                     }
 
-                    if(owner and not no_update and(r_write_pktid.read() != TYPE_SC))
+                    if (owner and not no_update and ((r_write_pktid.read() & 0x7) != TYPE_SC))
                     {
                         r_write_count = r_write_count.read() - 1;
@@ -3000,4 +3102,11 @@
                         if( wok )       // write data in cache
                         {
+                            
+                            if ((r_write_pktid.read() & 0x7) == TYPE_SC)
+                            {
+                                m_llsc_table.sc(r_write_address.read(),
+                                                r_write_sc_key.read());
+                            }
+
                             for(size_t word=0 ; word<m_words ; word++)
                             {
@@ -3067,8 +3176,9 @@
                     size_t min = r_write_word_index.read();
                     size_t max = r_write_word_index.read() + r_write_word_count.read();
-                    for(size_t i=min ; i<max ; i++) r_write_to_cc_send_data[i] = r_write_data[i];
+                    for(size_t i=min ; i<=max ; i++) r_write_to_cc_send_data[i] = r_write_data[i];
 
                     if( (r_write_copy.read() != r_write_srcid.read()) or
-                            (r_write_pktid.read() == TYPE_SC) or r_write_copy_inst.read())
+                       ((r_write_pktid.read() & 0x7) == TYPE_SC)      or
+                         r_write_copy_inst.read())
                     {
                         // put the first srcid in the fifo
@@ -3128,5 +3238,6 @@
                     // put the next srcid in the fifo
                     if( (entry.owner.srcid != r_write_srcid.read()) or 
-                            (r_write_pktid.read() == TYPE_SC) or entry.owner.inst)   
+                       ((r_write_pktid.read() & 0x7) == TYPE_SC)    or
+                         entry.owner.inst)
                     {
                         dec_upt_counter                = false;
@@ -3208,5 +3319,5 @@
                 // a new request in the write FIFO
                 {
-                    if(!r_write_to_tgt_rsp_req.read())
+                    if (not r_write_to_tgt_rsp_req.read())
                     {
                         // post the request to TGT_RSP_FSM
@@ -3218,14 +3329,10 @@
 
                         // try to get a new write request from the FIFO
-                        if(m_cmd_write_addr_fifo.rok())
-                        {
-                            if((m_cmd_write_pktid_fifo.read() & 0x7) == TYPE_SC)
-                                m_cpt_sc++;
+                        if (not m_cmd_write_addr_fifo.rok())
+                        {
+                            r_write_fsm = WRITE_IDLE;
+                        }
                             else
                             {
-                                m_cpt_write++;
-                                m_cpt_write_cells++;
-                            }
-
                             // consume a word in the FIFO & write it in the local buffer
                             cmd_write_fifo_get  = true;
@@ -3234,10 +3341,19 @@
                             r_write_address     = (addr_t)(m_cmd_write_addr_fifo.read());
                             r_write_word_index  = index;
-                            r_write_word_count  = 1;
+                            r_write_word_count  = 0;
                             r_write_data[index] = m_cmd_write_data_fifo.read();
                             r_write_srcid       = m_cmd_write_srcid_fifo.read();
                             r_write_trdid       = m_cmd_write_trdid_fifo.read();
                             r_write_pktid       = m_cmd_write_pktid_fifo.read();
-                            r_write_pending_sc  = false;
+
+                            // if SC command, get the SC key
+                            if ((m_cmd_write_pktid_fifo.read() & 0x7) == TYPE_SC)
+                            {
+                                assert( not m_cmd_write_eop_fifo.read() &&
+                                        "MEMC ERROR in WRITE_RSP state: "
+                                        "invalid packet format for SC command");
+
+                                r_write_sc_key = m_cmd_write_data_fifo.read();
+                            } 
 
                             // initialize the be field for all words
@@ -3248,5 +3364,5 @@
                             }
 
-                            if(m_cmd_write_eop_fifo.read() or ((m_cmd_write_pktid_fifo.read() & 0x7)  == TYPE_SC))
+                            if (m_cmd_write_eop_fifo.read())
                             {
                                 r_write_fsm = WRITE_DIR_REQ;
@@ -3256,8 +3372,4 @@
                                 r_write_fsm = WRITE_NEXT;
                             }
-                        }
-                        else
-                        {
-                            r_write_fsm = WRITE_IDLE;
                         }
 
@@ -3302,23 +3414,39 @@
                         bool    wok       = not m_trt.full(wok_index);
 
-                        if(hit_read)      // register the modified data in TRT
+                        // wait an empty entry in TRT
+                        if(not hit_read and (not wok or hit_write))
+                        {
+                            r_write_fsm       = WRITE_WAIT;
+                            m_cpt_trt_full++;
+
+                            break;
+                        }
+
+                        if ((r_write_pktid.read() & 0x7) == TYPE_SC)
+                        {
+                            m_llsc_table.sc(r_write_address.read(),
+                                            r_write_sc_key.read());
+                        }
+
+                        // register the modified data in TRT
+                        if (hit_read)
                         {
                             r_write_trt_index = hit_index;
                             r_write_fsm       = WRITE_MISS_TRT_DATA;
                             m_cpt_write_miss++;
-                        }
-                        else if(wok and !hit_write)      // set a new entry in TRT
+                            break;
+                        }
+
+                        // set a new entry in TRT
+                        if (wok and not hit_write)
                         {
                             r_write_trt_index = wok_index;
                             r_write_fsm       = WRITE_MISS_TRT_SET;
                             m_cpt_write_miss++;
-                        }
-                        else    // wait an empty entry in TRT
-                        {
-                            r_write_fsm       = WRITE_WAIT;
-                            m_cpt_trt_full++;
-                        }
-                        m_cpt_write_fsm_n_trt_lock++;
-                    }
+                            break;
+                        }
+
+                        assert(false && "VCI_MEM_CACHE ERROR: this part must not be reached");
+                        }
 
                     m_cpt_write_fsm_trt_lock++;
@@ -3406,5 +3534,4 @@
                     {
                         r_write_to_ixr_cmd_req   = true;
-                        r_write_to_ixr_cmd_put   = false;
                         r_write_to_ixr_cmd_index = r_write_trt_index.read();
                         r_write_fsm              = WRITE_RSP;
@@ -3412,5 +3539,7 @@
 #if DEBUG_MEMC_WRITE
                         if(m_debug)
-                            std::cout << "  <MEMC " << name() << " WRITE_MISS_XRAM_REQ> Post a GET request to the IXR_CMD FSM" << std::endl;
+                            std::cout << "  <MEMC " << name() 
+                                      << " WRITE_MISS_XRAM_REQ> Post a GET request to the"
+                                      << " IXR_CMD FSM" << std::endl;
 #endif
                     }
